'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

class ExceptionBase extends Error {
    constructor(typeName, message, line = 0, column = 0) {
        const lineAndColumnText = line > 0 && column > 0 ? ` at line ${line}, column ${column}` : '';
        const str = `${typeName}${lineAndColumnText}: ${message}`;
        super(str);
        this.str = str;
        this.line = line;
        this.column = column;
    }
    toString() {
        return this.str;
    }
}

class GrammarException extends ExceptionBase {
    constructor(message, line = 0, column = 0) {
        super('GrammarException', message, line, column);
    }
}

var n,t,e,a,r;!function(n){n[n.UndefinedSymbol=0]="UndefinedSymbol",n[n.Lambda=1]="Lambda",n[n.Dot=2]="Dot",n[n.terminalBegin=3]="terminalBegin",n[n.terminalEnd=4]="terminalEnd",n[n.terminalAssign=5]="terminalAssign",n[n.terminalSemicolon=6]="terminalSemicolon",n[n.terminalRead=7]="terminalRead",n[n.terminalWrite=8]="terminalWrite",n[n.terminalLeftBracket=9]="terminalLeftBracket",n[n.terminalRightBracket=10]="terminalRightBracket",n[n.terminalLeftSquareBracket=11]="terminalLeftSquareBracket",n[n.terminalRightSquareBracket=12]="terminalRightSquareBracket",n[n.terminalOrBar=13]="terminalOrBar",n[n.terminalComma=14]="terminalComma",n[n.terminalID=15]="terminalID",n[n.terminalVariable=16]="terminalVariable",n[n.terminalIntegerLiteral=17]="terminalIntegerLiteral",n[n.terminalFloatLiteral=18]="terminalFloatLiteral",n[n.terminalStringLiteral=19]="terminalStringLiteral",n[n.terminalPlus=20]="terminalPlus",n[n.terminalMinus=21]="terminalMinus",n[n.terminalCond=22]="terminalCond",n[n.terminalLet=23]="terminalLet",n[n.terminalLetStar=24]="terminalLetStar",n[n.terminalDefine=25]="terminalDefine",n[n.terminalIf=26]="terminalIf",n[n.terminalWhile=27]="terminalWhile",n[n.terminalSet=28]="terminalSet",n[n.terminalMultiply=29]="terminalMultiply",n[n.terminalDivide=30]="terminalDivide",n[n.terminalEquals=31]="terminalEquals",n[n.terminalLessThan=32]="terminalLessThan",n[n.terminalGreaterThan=33]="terminalGreaterThan",n[n.terminalPrint=34]="terminalPrint",n[n.terminalCons=35]="terminalCons",n[n.terminalCar=36]="terminalCar",n[n.terminalCdr=37]="terminalCdr",n[n.terminalNumberPred=38]="terminalNumberPred",n[n.terminalSymbolPred=39]="terminalSymbolPred",n[n.terminalListPred=40]="terminalListPred",n[n.terminalNullPred=41]="terminalNullPred",n[n.terminalStringPred=42]="terminalStringPred",n[n.terminalApostrophe=43]="terminalApostrophe",n[n.terminalDot=44]="terminalDot",n[n.terminalList=45]="terminalList",n[n.terminalRplaca=46]="terminalRplaca",n[n.terminalRplacd=47]="terminalRplacd",n[n.terminalDefineMacro=48]="terminalDefineMacro",n[n.terminalQuoteKeyword=49]="terminalQuoteKeyword",n[n.terminalRandom=50]="terminalRandom",n[n.terminalToString=51]="terminalToString",n[n.terminalListToString=52]="terminalListToString",n[n.terminalStringToList=53]="terminalStringToList",n[n.terminalStringToSymbol=54]="terminalStringToSymbol",n[n.terminalSin=55]="terminalSin",n[n.terminalCos=56]="terminalCos",n[n.terminalTan=57]="terminalTan",n[n.terminalPow=58]="terminalPow",n[n.terminalExp=59]="terminalExp",n[n.terminalLn=60]="terminalLn",n[n.terminalFloor=61]="terminalFloor",n[n.terminalAtan2=62]="terminalAtan2",n[n.terminalThrow=63]="terminalThrow",n[n.terminalStringLessThan=64]="terminalStringLessThan",n[n.terminalPrimOpPred=65]="terminalPrimOpPred",n[n.terminalClosurePred=66]="terminalClosurePred",n[n.terminalLambdaKeyword=67]="terminalLambdaKeyword",n[n.terminalLetRec=68]="terminalLetRec",n[n.terminalCallCC=69]="terminalCallCC",n[n.terminalNameBeginningWithCapital=70]="terminalNameBeginningWithCapital",n[n.terminalNameNotBeginningWithCapital=71]="terminalNameNotBeginningWithCapital",n[n.terminalFrom=72]="terminalFrom",n[n.terminalInferPred=73]="terminalInferPred",n[n.terminalNotSymbol=74]="terminalNotSymbol",n[n.terminalIs=75]="terminalIs",n[n.terminalFn=76]="terminalFn",n[n.terminalThickArrow=77]="terminalThickArrow",n[n.terminalIn=78]="terminalIn",n[n.terminalTrue=79]="terminalTrue",n[n.terminalFalse=80]="terminalFalse",n[n.terminalComb=81]="terminalComb",n[n.terminalInc=82]="terminalInc",n[n.terminalDec=83]="terminalDec",n[n.terminalAnd=84]="terminalAnd",n[n.terminalOr=85]="terminalOr",n[n.terminalIsZero=86]="terminalIsZero",n[n.terminalEOF=87]="terminalEOF",n[n.nonterminalStart=88]="nonterminalStart",n[n.nonterminalProgram=89]="nonterminalProgram",n[n.nonterminalStatementList=90]="nonterminalStatementList",n[n.nonterminalStatementTail=91]="nonterminalStatementTail",n[n.nonterminalStatement=92]="nonterminalStatement",n[n.nonterminalIDList=93]="nonterminalIDList",n[n.nonterminalIDTail=94]="nonterminalIDTail",n[n.nonterminalExprList=95]="nonterminalExprList",n[n.nonterminalExprTail=96]="nonterminalExprTail",n[n.nonterminalExpression=97]="nonterminalExpression",n[n.nonterminalTerm=98]="nonterminalTerm",n[n.nonterminalPrimaryTail=99]="nonterminalPrimaryTail",n[n.nonterminalPrimary=100]="nonterminalPrimary",n[n.nonterminalAddOp=101]="nonterminalAddOp",n[n.nonterminalBracketedEntity=102]="nonterminalBracketedEntity",n[n.nonterminalInput=103]="nonterminalInput",n[n.nonterminalFunDef=104]="nonterminalFunDef",n[n.nonterminalFunction=105]="nonterminalFunction",n[n.nonterminalArgList=106]="nonterminalArgList",n[n.nonterminalVariableList=107]="nonterminalVariableList",n[n.nonterminalVariable=108]="nonterminalVariable",n[n.nonterminalValue=109]="nonterminalValue",n[n.nonterminalBracketedExpression=110]="nonterminalBracketedExpression",n[n.nonterminalExpressionList=111]="nonterminalExpressionList",n[n.nonterminalOptr=112]="nonterminalOptr",n[n.nonterminalValueOp=113]="nonterminalValueOp",n[n.nonterminalQuotedConst=114]="nonterminalQuotedConst",n[n.nonterminalSExpression=115]="nonterminalSExpression",n[n.nonterminalSExpressionList=116]="nonterminalSExpressionList",n[n.nonterminalSymbol=117]="nonterminalSymbol",n[n.nonterminalMacroDef=118]="nonterminalMacroDef",n[n.nonterminalExprPairList=119]="nonterminalExprPairList",n[n.nonterminalLetKeyword=120]="nonterminalLetKeyword",n[n.nonterminalVarExprList=121]="nonterminalVarExprList",n[n.nonterminalBracketedInput=122]="nonterminalBracketedInput",n[n.nonterminalUnbracketedInput=123]="nonterminalUnbracketedInput",n[n.nonterminalSExpressionListTail=124]="nonterminalSExpressionListTail",n[n.nonterminalClause=125]="nonterminalClause",n[n.nonterminalQuery=126]="nonterminalQuery",n[n.nonterminalGoal=127]="nonterminalGoal",n[n.nonterminalClauseTail=128]="nonterminalClauseTail",n[n.nonterminalGoalList=129]="nonterminalGoalList",n[n.nonterminalGoalListTail=130]="nonterminalGoalListTail",n[n.nonterminalList=131]="nonterminalList",n[n.nonterminalListContents=132]="nonterminalListContents",n[n.nonterminalListContentsTail=133]="nonterminalListContentsTail",n[n.nonterminalFunctorExpression=134]="nonterminalFunctorExpression",n[n.nonterminalTailOfGoalOrFunctorExpression=135]="nonterminalTailOfGoalOrFunctorExpression",n[n.nonterminalExpressionListTail=136]="nonterminalExpressionListTail",n[n.nonterminalLambdaExpression=137]="nonterminalLambdaExpression",n[n.nonterminalLetStatement=138]="nonterminalLetStatement",n[n.nonterminalFunctionCall=139]="nonterminalFunctionCall";}(n||(n={})),function(n){n[n.MinimalLanguage=0]="MinimalLanguage",n[n.Micro=1]="Micro",n[n.Chapter1=2]="Chapter1",n[n.LISP=3]="LISP",n[n.APL=4]="APL",n[n.Scheme=5]="Scheme",n[n.SASL=6]="SASL",n[n.CLU=7]="CLU",n[n.Smalltalk=8]="Smalltalk",n[n.Prolog=9]="Prolog",n[n.Prolog2=10]="Prolog2",n[n.Inference=11]="Inference",n[n.JSON=12]="JSON",n[n.EcstaSKI=13]="EcstaSKI",n[n.Adso=14]="Adso",n[n.LambdaCalculus=15]="LambdaCalculus",n[n.LambdaCalculusWithAugmentedSyntax=16]="LambdaCalculusWithAugmentedSyntax",n[n.LambdaCalculusIntegerExtension=17]="LambdaCalculusIntegerExtension";}(t||(t={})),function(n){n[n.MidnightHack=1]="MidnightHack",n[n.FiniteStateMachine=2]="FiniteStateMachine";}(e||(e={})),function(n){n[n.tokenNone=1]="tokenNone",n[n.tokenIntLit=2]="tokenIntLit",n[n.tokenFltLit=3]="tokenFltLit",n[n.tokenStrLit=4]="tokenStrLit",n[n.tokenStrLit2=5]="tokenStrLit2",n[n.tokenIdent=6]="tokenIdent",n[n.tokenBoolIdent=7]="tokenBoolIdent",n[n.tokenSkolemIdent=8]="tokenSkolemIdent",n[n.tokenVariable=9]="tokenVariable",n[n.tokenMult=10]="tokenMult",n[n.tokenDiv=11]="tokenDiv",n[n.tokenPlus=12]="tokenPlus",n[n.tokenMinus=13]="tokenMinus",n[n.tokenEqual=14]="tokenEqual",n[n.tokenNotEqual=15]="tokenNotEqual",n[n.tokenLess=16]="tokenLess",n[n.tokenLessEqual=17]="tokenLessEqual",n[n.tokenGreater=18]="tokenGreater",n[n.tokenGreaterEqual=19]="tokenGreaterEqual",n[n.tokenSemicolon=20]="tokenSemicolon",n[n.tokenComma=21]="tokenComma",n[n.token2OrBar=22]="token2OrBar",n[n.token2Ampersand=23]="token2Ampersand",n[n.tokenLeftBracket=24]="tokenLeftBracket",n[n.tokenRightBracket=25]="tokenRightBracket",n[n.tokenAssign=26]="tokenAssign",n[n.tokenArrow=27]="tokenArrow",n[n.tokenExclamation=28]="tokenExclamation",n[n.tokenApostrophe=29]="tokenApostrophe",n[n.tokenOctothorpe=30]="tokenOctothorpe",n[n.tokenDollar=31]="tokenDollar",n[n.tokenDot=32]="tokenDot",n[n.tokenLeftSquareBracket=33]="tokenLeftSquareBracket",n[n.tokenRightSquareBracket=34]="tokenRightSquareBracket",n[n.tokenOrBar=35]="tokenOrBar",n[n.tokenColon=36]="tokenColon",n[n.tokenLeftCurlyBrace=37]="tokenLeftCurlyBrace",n[n.tokenRightCurlyBrace=38]="tokenRightCurlyBrace",n[n.tokenQuoteKeyword=39]="tokenQuoteKeyword",n[n.tokenQuestionMinus=40]="tokenQuestionMinus",n[n.tokenColonMinus=41]="tokenColonMinus",n[n.tokenEqualLessThan=42]="tokenEqualLessThan",n[n.tokenBackslashPlus=43]="tokenBackslashPlus",n[n.tokenBackslashEqual=44]="tokenBackslashEqual",n[n.tokenEqualEqual=45]="tokenEqualEqual",n[n.tokenBackslashEqualEqual=46]="tokenBackslashEqualEqual",n[n.tokenEqualColonEqual=47]="tokenEqualColonEqual",n[n.tokenEqualBackslashEqual=48]="tokenEqualBackslashEqual",n[n.tokenMinusMinusGreaterThan=49]="tokenMinusMinusGreaterThan",n[n.tokenEqualDotDot=50]="tokenEqualDotDot",n[n.tokenCaret=51]="tokenCaret",n[n.tokenLowercaseGreekLetterLambda=52]="tokenLowercaseGreekLetterLambda",n[n.tokenEOF=53]="tokenEOF",n[n.stateStart=54]="stateStart",n[n.stateError=55]="stateError",n[n.stateStrLitOpen=56]="stateStrLitOpen",n[n.stateStrLit2Open=57]="stateStrLit2Open",n[n.stateIntLitDot=58]="stateIntLitDot",n[n.stateQuestion=59]="stateQuestion",n[n.stateAmpersand=60]="stateAmpersand",n[n.stateAt=61]="stateAt",n[n.stateDollar=62]="stateDollar",n[n.stateBackslash=63]="stateBackslash",n[n.stateEqualColon=64]="stateEqualColon",n[n.stateEqualBackslash=65]="stateEqualBackslash",n[n.stateMinusMinus=66]="stateMinusMinus",n[n.stateEqualDot=67]="stateEqualDot";}(a||(a={})),function(n){n[n.LL1=0]="LL1",n[n.LR0=1]="LR0",n[n.LR1=2]="LR1",n[n.SLR1=3]="SLR1",n[n.LALR1=4]="LALR1";}(r||(r={}));

const typenameProduction = 'Production';
function isProduction(obj) {
    const otherProduction = obj;
    const lhs = otherProduction.lhs;
    const rhs = otherProduction.rhs;
    return (typeof otherProduction !== 'undefined' &&
        otherProduction.typename === typenameProduction &&
        typeof lhs !== 'undefined' &&
        typeof lhs === 'number' &&
        typeof rhs !== 'undefined' &&
        rhs instanceof Array &&
        rhs.every((element) => typeof element === 'number' || typeof element === 'string'));
}
class Production {
    constructor(lhs, rhs, num) {
        this.lhs = lhs;
        this.rhs = rhs;
        this.num = num;
        this.typename = typenameProduction;
    }
    toString() {
        const lhsAsString = n[this.lhs];
        const rhsAsString = this.rhs
            .map((s) => {
            if (typeof s === 'string') {
                return s;
            }
            else {
                return n[s];
            }
        })
            .join(' ');
        return `${this.num}: ${lhsAsString} -> ${rhsAsString}`;
    }
    equals(other) {
        const otherProduction = other;
        if (!isProduction(other) ||
            this.lhs !== otherProduction.lhs ||
            this.rhs.length !== otherProduction.rhs.length) {
            return false;
        }
        for (let i = 0; i < this.rhs.length; i++) {
            if (this.rhs[i] !== otherProduction.rhs[i]) {
                return false;
            }
        }
        return true;
    }
    getRHSWithNoSemanticActions() {
        return this.rhs
            .filter((s) => typeof s !== 'string')
            .map((s) => s);
    }
    stripOutSemanticActions() {
        return new Production(this.lhs, this.getRHSWithNoSemanticActions(), this.num);
    }
    containsSymbol(symbol) {
        return (this.lhs === symbol ||
            typeof this.rhs.find((s) => s === symbol) !== 'undefined');
    }
}
function createProduction(lhs, rhs, num = 0) {
    return new Production(lhs, rhs, num);
}

class GrammarBase {
    constructor(startSymbol) {
        this.startSymbol = startSymbol;
        this.terminals = [];
        this.nonTerminals = [];
        this.productions = [];
    }
    findStartingProduction() {
        const results = [];
        for (const p of this.productions) {
            if (p.lhs === this.startSymbol) {
                const p2 = p.stripOutSemanticActions();
                if (p2.rhs.length > 0) {
                    const lastObject = p2.rhs[p2.rhs.length - 1];
                    if (lastObject === n.terminalEOF) {
                        results.push(p2);
                    }
                }
            }
        }
        if (results.length !== 1) {
            throw new GrammarException(`GrammarBase.FindStartingProduction() : Expected one starting production; found ${results.length}.`);
        }
        return results[0];
    }
    addProduction(lhs, rhs, n = NaN) {
        this.productions.push(createProduction(lhs, rhs, Number.isNaN(n) ? this.productions.length + 1 : n));
    }
}

exports.ExceptionBase = ExceptionBase;
exports.GrammarBase = GrammarBase;
exports.GrammarException = GrammarException;
exports.createProduction = createProduction;
exports.isProduction = isProduction;
