import { GrammarSymbol, IGrammar, IProduction, IToken, ParserSelector, ProductionRhsElementType, SemanticStackType } from 'thaw-interpreter-types';
export declare abstract class GrammarBase implements IGrammar {
    readonly startSymbol: GrammarSymbol;
    readonly terminals: GrammarSymbol[];
    readonly nonTerminals: GrammarSymbol[];
    readonly productions: IProduction[];
    protected constructor(startSymbol: GrammarSymbol);
    abstract get languageName(): string;
    abstract get selectorsOfCompatibleParsers(): ParserSelector[];
    abstract executeSemanticAction(semanticStack: SemanticStackType, action: string): void;
    abstract tokenToSymbol(token: IToken): GrammarSymbol;
    abstract pushTokenOntoSemanticStack(semanticStack: SemanticStackType, tokenAsSymbol: GrammarSymbol, token: IToken): void;
    findStartingProduction(): IProduction;
    protected addProduction(lhs: GrammarSymbol, rhs: ProductionRhsElementType[], n?: number): void;
}
//# sourceMappingURL=grammar-base.d.ts.map